#include "AttackerData.h"

AttackerData::AttackerData(BWAPI::Unit * u) : 
	UnitData(u),
	state(AttackerState::None),
	target(NULL),
	now_location(NULL)
{
}

AttackerData::AttackerData() : 
	UnitData()
{
}


AttackerData::~AttackerData(void){}

void AttackerData::update(){
	unit_update();
	hp = getUnit()->getHitPoints();

	if(state == AttackerState::Attack || state == AttackerState::Retreat || state == AttackerState::Defense){
		/*if(!CimexFlag::scout_flag && getType() == BWAPI::UnitTypes::Zerg_Zergling){
			state = AttackerState::Scout;
			target = NULL;
			CimexFlag::scout_flag = true;
		}*/
	}
}

void AttackerData::eupdate(){
	if(getUnit()->isVisible()){
		unit_update();
		hp = getUnit()->getHitPoints() + getUnit()->getShields();
	}
}

char * AttackerData::getStateChar() const
{
	if(state == 0) return "None";
	else if(state == 1) return "Attack";
	else if(state == 2) return "Retreat";
	else if(state == 3) return "Defense";
	else if(state == 4) return "Scout";
	else return "????";
}

int AttackerData::getState() const
{ return state;}

int AttackerData::getHp()const
{ return hp;}

BWAPI::Unit * AttackerData::getTarget()
{ return target;}


BWTA::BaseLocation* AttackerData::getNowLocation() const
{ return now_location;}


void AttackerData::setTarget(BWAPI::Unit* u)
{ target = u;}

void AttackerData::setState(const int &i){
	if(i >= AttackerState::Max) return;
	state = i;
	return;
}

void AttackerData::setNowLocation(BWTA::BaseLocation* b){
	now_location = b;
}

