#include "AttackerManager.h"

boost::random::mt19937 RndGen(std::rand());
boost::random::uniform_int_distribution<int> Uniformi(0, std::numeric_limits<int>::max());

AttackerManager::AttackerManager(void) :
	enemy_simulate_min(1000000),
	last_target(NULL),
	now_state(AttackerState::Attack),
	enemy_hp(0),
	morph_hydralisk(0),
	morph_mutalisk(0),
	trampled_muta(false)
{
	initAttackerNum(&pre_attackernum);
	attacker_corps.resize(15);
	for(std::vector<Corps>::iterator cp = attacker_corps.begin(); cp != attacker_corps.end(); cp++){
		cp->corps.clear();
		cp->state = AttackerState::Attack;
		cp->selfsimu = 0;
		cp->enemysimu = 0;
		cp->target = NULL;
		cp->target_position = BWAPI::Positions::None;
		cp->flyer = false;
		cp->flyweapon = false;
	}

	mutalisk_corps.corps.clear();
	mutalisk_corps.state = AttackerState::Attack;
	mutalisk_corps.selfsimu = 0;
	mutalisk_corps.enemysimu = 0;
	mutalisk_corps.target = NULL;
	mutalisk_corps.target_position = BWAPI::Positions::None;
	mutalisk_corps.flyer = true;
	mutalisk_corps.flyweapon = true;
	morph_corps.clear();
}



AttackerManager::~AttackerManager(void)
{
}

void AttackerManager::update(){
	if(!attackers.empty()){
		if(logging_flag) out << attackers.size() << std::endl;
		if(logging_flag) out << "1" << std::endl;
		updateAttackerNum();

		int corpnum = 0;
		int y = 200;

		for(std::vector<Corps>::iterator cp = attacker_corps.begin(); cp != attacker_corps.end(); cp++){
			bool state_change = false; //ԂύXꂽƂture -> attackɑ΂tO
			if(logging_flag) out << "2" << std::endl;
			if(cp->corps.empty()) cp->target = changeTarget(mapdata.getFrontLine()->getPosition(), cp->flyweapon, cp->flyer);
			else{
				BWAPI::Unit *tg = NULL;
				if(cp->target != NULL) tg = cp->target;
				BOOST_FOREACH(AttackerData *a, cp->corps){
					cp->target = changeTarget(a->getPosition(), cp->flyweapon, cp->flyer);
					if(tg != NULL) if(tg != cp->target) state_change = true;
					break;
				}
			}
			if(logging_flag) out << "3" << std::endl;
			cp->enemysimu = cp->enemysimu * 1.0001;
			if(logging_flag) out << "4" << std::endl;


			if(cp->state == AttackerState::Attack){
				if(logging_flag) out << " 4-1 " << std::endl;
				updateSimulateAttack((*cp));
				//out4 << cp->enemysimu << "," << cp->selfsimu << "  " << simulateAttack((*cp)) << "," << inMyBase(corpnum) << "," <<  (mapdata.getMybases().size() == 0) << std::endl;
				if(mapdata.getEnemybases().size() > 0){
					cp->target_position = mapdata.getNearEnemybase()->getPosition();
				}else{
					BOOST_FOREACH(BWTA::BaseLocation* b, BWTA::getStartLocations()){
							if(b == BWTA::getStartLocation(BWAPI::Broodwar->self())) continue;
							cp->target_position = b->getPosition();
					}
				}
				if(logging_flag) out << " 4-2 " << std::endl;
				//simulation = lose && baseɓGȂ && Mybase => Retreat
				if(!simulateAttack((*cp)) && !inMyBase(corpnum) && mapdata.getMybases().size() != 0){
					/*cp->state = AttackerState::Retreat;
					cp->target_position = mapdata.getWaitPosition();*/
					cp->state = AttackerState::Defense;
					state_change = true;
					cp->target_position = mapdata.getFrontLine()->getPosition();
				}


			/*}else if(cp->state == AttackerState::Retreat){
				for(std::set<AttackerData*>::iterator u = cp->corps.begin(); u != cp->corps.end(); u++){
					if((*u)->getUnit()->isUnderAttack()){
						updateSimulateAttack((*cp));
						break;
					}
				}
				if(simulateAttack((*cp)) || inMyBase(corpnum) || mapdata.getMybases().size() == 0){
					cp->state = AttackerState::Attack;
					state_change = true;
					if(mapdata.getEnemybases().size() > 0)
						cp->target_position = mapdata.getNearEnemybase()->getPosition();
				}else{
					cp->target_position = mapdata.getWaitPosition();
					for(std::set<AttackerData*>::iterator u = cp->corps.begin(); u != cp->corps.end(); u++){
						if((*u)->getUnit()->isUnderAttack()){
							cp->state = AttackerState::Defense;
							state_change = true;
							cp->target_position = mapdata.getFrontLine()->getPosition();
							break;
						}
					}
				}*/


			}else if(cp->state == AttackerState::Defense){
				if(logging_flag) out << " 4-3 " << std::endl;
				//updateSimulateAttack((*cp));
				if(simulateAttack((*cp)) || inMyBase(corpnum) || mapdata.getMybases().size() == 0){
					if(logging_flag) out << " 4-4 " << std::endl;
					cp->state = AttackerState::Attack;
					state_change = true;
					//out4 << "!!!!!!!!" << corpnum << ":" << cp->enemysimu << "," << cp->selfsimu << "  " << simulateAttack((*cp)) << "," << inMyBase(corpnum) << "," <<  (mapdata.getMybases().size() == 0) << std::endl;
					if(mapdata.getEnemybases().size() > 0)
						cp->target_position = mapdata.getNearEnemybase()->getPosition();
				}else{
					if(logging_flag) out << " 4-5 " << std::endl;
					cp->target_position = mapdata.getFrontLine()->getPosition();
				}
				
			}


			if(logging_flag) out << "5" << std::endl;
			//out4 << "Corps:" << corpnum << std::endl;
			
			if(!cp->corps.empty()){
				BOOST_FOREACH(AttackerData *a, cp->corps){
					//out4 << a->getType().getName().c_str() << "," << a->getUnit()->getType().getName().c_str() << std::endl;
					a->setState(cp->state);
					if(logging_flag) out << "5-0" << std::endl;
					if(cp->target != NULL && cp->target->exists() && cp->target->getHitPoints() > 0) a->setTarget(cp->target);
					if(a->getState() == AttackerState::Attack && cp->target != NULL && cp->target->isVisible()){
						if(logging_flag) out << "5-1" << std::endl;
						attack(*a, state_change);
					}else{
						if(logging_flag) out << "5-2" << std::endl;
						if(cp->state == AttackerState::Defense && a->getType() == BWAPI::UnitTypes::Zerg_Lurker) //Lurker͖܂ׂ
							a->getUnit()->burrow();
						else attack(*a, cp->target_position, state_change);
					}
				}
			}
			//out4 << std::endl;
			if(logging_flag) out << "5-3" << std::endl;
			//BWAPI::Broodwar->drawTextScreen(10, y, "Corp%d: %d %d, %4f, %4f, %d", corpnum, cp->corps.size(), cp->state, cp->selfsimu, cp->enemysimu, simulateAttack((*cp)));
			//y += 10;
			if(logging_flag) out << "6" << std::endl;
			corpnum++;
		}
		

		if(!morph_corps.empty()){
			BWAPI::Position morph_position = mapdata.getFrontLine()->getPosition();
			//out4 << "MCorps:" << std::endl;
			BOOST_FOREACH(AttackerData *a, morph_corps){
				//out4 << a->getType().getName().c_str() << "," << a->getUnit()->getType().getName().c_str() << std::endl;
				attack(*a, mapdata.getFrontLine()->getPosition(), false);
			}
			//out4 << std::endl;
			BWAPI::Broodwar->drawTextScreen(10, y, "morph_corps: %d", morph_corps.size());
		}

		//P3̈ȏŃX^[g
		if(mutalisk_corps.corps.size() >= 3){
			//BWAPI::Broodwar->drawTextScreen(10, y, "MCorp: %d %d, %4f, %4f, %d", corpnum, mutalisk_corps.corps.size(), mutalisk_corps.state, mutalisk_corps.selfsimu, mutalisk_corps.enemysimu, simulateAttack(mutalisk_corps));
			//out4 << "MutaliskCorps:" << std::endl;
			bool state_change = false;
			BWAPI::Position now_p = BWAPI::Positions::None; //P̌ݒn
			BOOST_FOREACH(AttackerData *a, mutalisk_corps.corps){
				now_p = a->getPosition(); //ݒnIDłႢjbgɈˑ
				mutalisk_corps.target = changeTarget(mutalisk_corps.target_position, mutalisk_corps.flyweapon, true); //^[Qbg`FW
				break;
			}

			if(mutalisk_corps.target_position == BWAPI::Positions::None) mutalisk_corps.target_position = getMutaliskPosition(); //GnResourceɌ
			if(BWAPI::Broodwar->getFrameCount() % (24 * 5) == 0){ //5bɈx^[QbgGwnmFiɟrłĂ\̂Łj
				std::pair<BWTA::BaseLocation*, bool> eb;
				BWTA::BaseLocation *now_b = BWTA::getNearestBaseLocation(mutalisk_corps.target_position);
				bool flag = true;
				BOOST_FOREACH(eb, mapdata.getEnemybases()){
					if(eb.first == now_b){
						flag = false;
						break;
					}
				}
				if(flag) mutalisk_corps.target_position = getMutaliskPosition();
			}
			if(mutalisk_corps.state == AttackerState::Attack){
				updateSimulateAttack(mutalisk_corps);
				if(!simulateAttack(mutalisk_corps) && mapdata.getMybases().size() != 0){
					mutalisk_corps.target_position = getMutaliskPosition();
					trampled_muta = false;
					mutalisk_corps.state = AttackerState::Retreat;
					state_change = true;
				}
			}else if(mutalisk_corps.state == AttackerState::Retreat){
				if(now_p.getApproxDistance(mutalisk_corps.target_position) < 256){
					mutalisk_corps.state = AttackerState::Attack;
					state_change = true;
				}
			}
			BOOST_FOREACH(AttackerData *a, mutalisk_corps.corps){
				//out4 << a->getType().getName().c_str() << "," << a->getUnit()->getType().getName().c_str() << std::endl;
				a->setState(mutalisk_corps.state);
				if(mutalisk_corps.target != NULL && mutalisk_corps.target->exists() && mutalisk_corps.target->getHitPoints() > 0) a->setTarget(mutalisk_corps.target);
				if(mutalisk_corps.target_position.getApproxDistance(a->getPosition()) < 1024 /*|| trampled_muta*/){
					trampled_muta = true;
					attack(*a, false); //trueɂׂȂ̂ȁH->attackMutaliskp̍ڂǉ
				}else
					attack(*a, mutalisk_corps.target_position, false);
			}
			//out4 << std::endl;
		}else{
			//2̈ȉ̊P

		}
		//BWAPI::Broodwar->drawTextScreen(10, 130, "mhydra : %d; %d, mmuta : %d", morph_hydralisk, build_order[BuildOrderData::build_order_index + 5][BuildOrderType::Lurker] - BuildOrderData::hold_num[BuildOrderType::Lurker], morph_mutalisk);
		//out4 << std::endl;
		//out4 << std::endl;
	}

}

void AttackerManager::initAttackerNum(AttackerNum *an){
	an->attacker_num  = 0;
	an->zergling_num  = 0;
	an->hydralisk_num = 0;
	an->lurker_num    = 0;
	an->mutalisk_num  = 0;
	an->scourge_num   = 0;
	an->defiler_num   = 0;
}

//1̂łɕωҐ
bool AttackerManager::updateAttackerNum(){
	AttackerNum all_num;
	initAttackerNum(&all_num);
	BOOST_FOREACH(AttackerData &a, attackers){
		if(&a == NULL || a.getUnit() == NULL) continue;
		if(a.getState() == AttackerState::Scout) continue;
		all_num.attacker_num++;
		if(a.getType() == BWAPI::UnitTypes::Zerg_Zergling)       all_num.zergling_num++;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Hydralisk) all_num.hydralisk_num++;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker)    all_num.lurker_num++;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk)  all_num.mutalisk_num++;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Scourge)   all_num.scourge_num++;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Defiler)   all_num.defiler_num++;
	}

	bool flag =  (all_num.attacker_num != pre_attackernum.attacker_num
				|| all_num.zergling_num != pre_attackernum.zergling_num
				|| all_num.hydralisk_num != pre_attackernum.hydralisk_num
				|| all_num.lurker_num != pre_attackernum.lurker_num
				|| all_num.mutalisk_num != pre_attackernum.mutalisk_num
				|| all_num.scourge_num != pre_attackernum.scourge_num
				|| all_num.defiler_num != pre_attackernum.defiler_num
				);

	if(flag){
		pre_attackernum.attacker_num = all_num.attacker_num;
		pre_attackernum.zergling_num = all_num.zergling_num;
		pre_attackernum.hydralisk_num = all_num.hydralisk_num;
		pre_attackernum.lurker_num = all_num.lurker_num;
		pre_attackernum.mutalisk_num = all_num.mutalisk_num;
		pre_attackernum.scourge_num = all_num.scourge_num;
		pre_attackernum.defiler_num = all_num.defiler_num;
		updateCorps(&all_num); //Ґ̂蒼
	}

	//for(std::vector<Corps>::iterator cp = attacker_corps.begin(); cp != attacker_corps.end(); cp++)
		//updateSimulateAttack((*cp));

	return flag;
}

//Ґ(nテjbgA󒆃jbg)~(nUA󒆍U)ŕ(edefiler1)
void AttackerManager::updateCorps(AttackerNum *all_num){
	//state͕ێ
	std::vector<int> pre_state(3);
	//simulationʂێ

	if(attacker_corps.empty()){
		for(int i=0; i<3; i++) pre_state[i] = AttackerState::Attack;
	}else{
		for(int i=0; i<3; i++){
			if(attacker_corps[i].state >= AttackerState::Attack && attacker_corps[i].state < AttackerState::Scout)
				pre_state[i] = attacker_corps[i].state;
			else
				pre_state[i] = AttackerState::Attack;
		}

	}

	morph_corps.clear();
	mutalisk_corps.corps.clear();

	for(std::vector<Corps>::iterator cp = attacker_corps.begin(); cp != attacker_corps.end(); cp++)
		cp->corps.clear();
	//attacker_corps.clear();

	int gg_num = all_num->zergling_num + all_num->lurker_num;
	int gf_num = all_num->hydralisk_num;
	int ff_num = all_num->mutalisk_num + all_num->scourge_num;
	attacker_corps.resize(3 + gg_num / 11 + gf_num / 11 + ff_num / 11);
	std::vector<int> corps_num(3 + gg_num / 11 + gf_num / 11 + ff_num / 11);

	int ffi = 2, gfi = 1, ggi = 0, defileri = 0, maxi = 2;
	BOOST_FOREACH(AttackerData &a, attackers){
		if(&a == NULL || a.getUnit() == NULL) continue;
		if(a.getState() == AttackerState::Scout) continue;
		if(a.getType() == BWAPI::UnitTypes::Zerg_Zergling || a.getType() == BWAPI::UnitTypes::Zerg_Lurker){
			attacker_corps[ggi].corps.insert(&a);
			attacker_corps[ggi].flyweapon = false;
			attacker_corps[ggi].flyer     = false;
			attacker_corps[ggi].state     = pre_state[0];
			corps_num[ggi]++;
			if(corps_num[ggi] == 11){
				ggi = maxi + 1;
				maxi++;
			}
		}else if(a.getType() == BWAPI::UnitTypes::Zerg_Hydralisk){
			if(morph_hydralisk > 0){
				morph_corps.insert(&a);
				morph_hydralisk--;
			}else{

				attacker_corps[gfi].corps.insert(&a);
				attacker_corps[gfi].flyweapon = true;
				attacker_corps[gfi].flyer     = false;
				attacker_corps[gfi].state     = pre_state[1];
				corps_num[gfi]++;
				if(corps_num[gfi] == 11){
					gfi = maxi + 1;
					maxi++;
				}
			}
		}else if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk || a.getType() == BWAPI::UnitTypes::Zerg_Scourge){
			if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk && morph_mutalisk > 0){
				morph_corps.insert(&a);
				morph_mutalisk--;
			}else{
				if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk && mutalisk_corps.corps.size() < 12){
					mutalisk_corps.corps.insert(&a);
					mutalisk_corps.flyweapon = true;
					mutalisk_corps.flyer     = true;
					mutalisk_corps.state     = pre_state[2];
				}else{

					attacker_corps[ffi].corps.insert(&a);
					attacker_corps[ffi].flyweapon = true;
					attacker_corps[ffi].flyer     = true;
					attacker_corps[ffi].state     = pre_state[2];
					corps_num[ffi]++;
					if(corps_num[ffi] == 11){
						ffi = maxi + 1;
						maxi++;
					}
				}
			}
		}else if(a.getType() == BWAPI::UnitTypes::Zerg_Defiler){
			attacker_corps[defileri].corps.insert(&a);
			corps_num[defileri]++;
			defileri++;
		}
	}
}

void AttackerManager::attack(AttackerData &a, bool first){
	if(a.getTarget() == NULL || !a.getTarget()->exists() || a.getTarget()->getHitPoints() <= 0) return;
	int range = 230;
	/*if(a.getType().groundWeapon() != BWAPI::WeaponTypes::None){
		range = a.getType().groundWeapon().maxRange();
	}else if(a.getType().airWeapon() != BWAPI::WeaponTypes::None){
		range = a.getType().airWeapon().maxRange();
	}*/

	//Defiler
	if(a.getType() == BWAPI::UnitTypes::Zerg_Defiler){
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), a.getTarget()->getPosition().x(), a.getTarget()->getPosition().y(), BWAPI::Colors::Yellow);
		BWAPI::Position DSp = getDarkSwarmTP(a, a.getTarget());
		//out4 << BWAPI::Broodwar->getFrameCount() << ":" << DSp.x() << "," << DSp.y() << " " << BWAPI::Positions::None.x() << "," << BWAPI::Positions::None.y() << "      " << DSp.isValid() << " " << BWAPI::Positions::None.isValid() << std::endl;
		if(DSp != BWAPI::Positions::None) a.getUnit()->useTech(BWAPI::TechTypes::Dark_Swarm, DSp);
		else a.getUnit()->move(a.getTarget()->getPosition());


	//Lurker
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker && a.getPosition().getApproxDistance(a.getTarget()->getPosition()) > range * 2  && a.getUnit()->isBurrowed()){
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), a.getTarget()->getPosition().x(), a.getTarget()->getPosition().y(), BWAPI::Colors::Yellow);

		bool flag = true;
		BOOST_FOREACH(BWAPI::Unit *u, a.getUnit()->getUnitsInRadius(128)){
			if(u->getPlayer() == BWAPI::Broodwar->enemy()) flag = false;
		}
		if(flag) a.getUnit()->unburrow();
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker && a.getPosition().getApproxDistance(a.getTarget()->getPosition()) <= range){
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), a.getTarget()->getPosition().x(), a.getTarget()->getPosition().y(), BWAPI::Colors::Yellow);
		a.getUnit()->burrow();


	//Mutalisk
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk){
		a.getUnit()->rightClick(a.getTarget());


	//other
	}else if(first){ //ԕω
		BWAPI::Position tp;
		tp = a.getTarget()->getPosition();
		tp.x() += ((Uniformi(RndGen) % 3) - 1) * TILE_SIZE;
		tp.y() += ((Uniformi(RndGen) % 3) - 1) * TILE_SIZE;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), tp.x(), tp.y(), BWAPI::Colors::Yellow);
		a.getUnit()->rightClick(tp);
	}else if(a.getPosition().getApproxDistance(a.getTarget()->getPosition()) >= range && !a.getUnit()->isMoving()){
		BWAPI::Position tp;
		tp = a.getTarget()->getPosition();
		tp.x() += ((Uniformi(RndGen) % 3) - 1) * TILE_SIZE;
		tp.y() += ((Uniformi(RndGen) % 3) - 1) * TILE_SIZE;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), tp.x(), tp.y(), BWAPI::Colors::Yellow);
		a.getUnit()->rightClick(tp);
	}
}

void AttackerManager::attack(AttackerData &a, BWAPI::Position p, bool first){
	if(p == NULL) return;
	if(logging_flag) out << "5-2-1" << std::endl;
	int range = 230;
	/*if(a.getType().groundWeapon() != BWAPI::WeaponTypes::None){
		range = a.getType().groundWeapon().maxRange();
	}else if(a.getType().airWeapon() != BWAPI::WeaponTypes::None){
		range = a.getType().airWeapon().maxRange();
	}*/
	
	//Defiler
	if(a.getType() == BWAPI::UnitTypes::Zerg_Defiler && a.getUnit()->getEnergy() >= 100){
		if(logging_flag) out << "5-2-2" << std::endl;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), p.x(), p.y(), BWAPI::Colors::Yellow);
		BWAPI::Position DSp = getDarkSwarmTP(a, a.getTarget());
		//out4 << BWAPI::Broodwar->getFrameCount() << ":" << DSp.x() << "," << DSp.y() << " " << BWAPI::Positions::None.x() << "," << BWAPI::Positions::None.y() << "      " << DSp.isValid() << " " << BWAPI::Positions::None.isValid() << std::endl;
		if(DSp != BWAPI::Positions::None) a.getUnit()->useTech(BWAPI::TechTypes::Dark_Swarm, DSp);
		else a.getUnit()->move(p);
		if(logging_flag) out << "5-2-3" << std::endl;

	//Lurker
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker && a.getPosition().getApproxDistance(p) > range * 2  && a.getUnit()->isBurrowed()){
		if(logging_flag) out << "5-2-4" << std::endl;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), p.x(), p.y(), BWAPI::Colors::Yellow);

		bool flag = true;
		BOOST_FOREACH(BWAPI::Unit *u, a.getUnit()->getUnitsInRadius(128)){
			if(u->getPlayer() == BWAPI::Broodwar->enemy()) flag = false;
		}
		if(flag) a.getUnit()->unburrow();
		if(logging_flag) out << "5-2-5" << std::endl;
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker && a.getPosition().getApproxDistance(p) <= range){
		if(logging_flag) out << "5-2-6" << std::endl;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), p.x(), p.y(), BWAPI::Colors::Yellow);
		a.getUnit()->burrow();
		if(logging_flag) out << "5-2-7" << std::endl;

	//Mutalisk
	}else if(a.getType() == BWAPI::UnitTypes::Zerg_Mutalisk){
		if(logging_flag) out << "5-2-8" << std::endl;
		a.getUnit()->rightClick(p);

		if(logging_flag) out << "5-2-9" << std::endl;

	//other
	}else if(first){ //ԕω
		if(logging_flag) out << "5-2-10" << std::endl;
		BWAPI::Position tp;
		tp = p;
		tp.x() += ((Uniformi(RndGen) % 7) - 3) * TILE_SIZE;
		tp.y() += ((Uniformi(RndGen) % 7) - 3) * TILE_SIZE;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), tp.x(), tp.y(), BWAPI::Colors::Yellow);
		a.getUnit()->rightClick(tp);
		if(logging_flag) out << "5-2-11" << std::endl;
		//a.getUnit()->rightClick(p);
	//̂ɓĂȂA܂͓PޒɍU󂯂Ă
	}else if((a.getPosition().getApproxDistance(p) > range && !a.getUnit()->isMoving()) /*|| ((a.getState() == AttackerState::Retreat || a.getState() == AttackerState::Defense) && a.getUnit()->isUnderAttack())*/){
		if(logging_flag) out << "5-2-12" << std::endl;
		BWAPI::Position tp;
		tp = p;
		tp.x() += ((Uniformi(RndGen) % 7) - 3) * TILE_SIZE;
		tp.y() += ((Uniformi(RndGen) % 7) - 3) * TILE_SIZE;
		a.getUnit()->rightClick(tp);
		//a.getUnit()->rightClick(p);
		//out4 << a.getPosition().getApproxDistance(p) << "," << (a.getPosition().getApproxDistance(p) > range) << "," << !a.getUnit()->isMoving() << std::endl;
		//BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), tp.x(), tp.y(), BWAPI::Colors::Blue);
		if(logging_flag) out << "5-2-13" << std::endl;
	}
}

bool AttackerManager::morph(BWAPI::UnitType type){
	bool flag = false;
	BOOST_FOREACH(AttackerData *a, morph_corps){
		if(a->getUnit()->isMorphing() || a->getUnit()->getBuildType() != BWAPI::UnitTypes::None){
			continue;
		}
		a->getUnit()->morph(type);
		flag = true;
		break;
	}
	return flag;
}

void AttackerManager::updateMorphNum(int hydralisk_num, int mutalisk_num){
	morph_hydralisk = hydralisk_num;
	morph_mutalisk  = mutalisk_num;
}

BWAPI::Unit* AttackerManager::changeTarget(BWAPI::Position p, bool flyweapon, bool flyer){
	double min_dis = DINF;
	BWAPI::Unit* min_unit;
	//炪flyerǂŗD揇ʂύX
	//炪fryweaponĂȂΓGflyer͖
	BOOST_FOREACH(AttackerData &ea, eattackers){
		int dis = 0;
		if(ea.getHp() <= 0) continue;
		if(ea.getType().isFlyer() && !flyweapon) continue;
		if(!ea.getUnit()->isVisible()
			|| ea.getUnit()->getPosition() == BWAPI::Positions::None
			|| ea.getUnit()->getPosition() == BWAPI::Positions::Invalid
			|| ea.getUnit()->getPosition() == BWAPI::Positions::Unknown)
			continue;
		if(flyer && ea.getUnit()->getType().airWeapon() != BWAPI::WeaponTypes::None && ea.getUnit()->getType().airWeapon() != BWAPI::WeaponTypes::Unknown){
			dis = p.getApproxDistance(ea.getPosition()) + 0;
		}else{
			dis = p.getApproxDistance(ea.getPosition()) + 200;
		}
		if(dis < min_dis){
			min_dis = p.getApproxDistance(ea.getPosition());
			min_unit = ea.getUnit();
		}
	}

	BOOST_FOREACH(WorkerData &ew, eworkers){
		if(ew.getHp() <= 0) continue;
		if(ew.getType().isFlyer() && !flyweapon) continue;
		if(!ew.getUnit()->isVisible()
			|| ew.getUnit()->getPosition() == BWAPI::Positions::None 
			|| ew.getUnit()->getPosition() == BWAPI::Positions::Invalid
			|| ew.getUnit()->getPosition() == BWAPI::Positions::Unknown)
			continue;
		if(p.getApproxDistance(ew.getPosition()) + 200 < min_dis){
			min_dis = p.getApproxDistance(ew.getPosition()) + 200;
			min_unit = ew.getUnit();
		}
	}

	BOOST_FOREACH(BuildingData &eb, ebuildings){
		if(eb.getHp() <= 0) continue;
		if(eb.getType().isFlyer() && !flyweapon) continue;
		if(!eb.getUnit()->isVisible()
			|| eb.getUnit()->getPosition() == BWAPI::Positions::None 
			|| eb.getUnit()->getPosition() == BWAPI::Positions::Invalid
			|| eb.getUnit()->getPosition() == BWAPI::Positions::Unknown)
			continue;
		if(p.getApproxDistance(eb.getPosition()) + 400 < min_dis){
			min_dis = p.getApproxDistance(eb.getPosition()) + 400;
			min_unit = eb.getUnit();
		}
	}

	BOOST_FOREACH(OtherUnitData &eo, eothers){
		if(eo.getHp() <= 0 || eo.getType().isFlyer()) continue;
		if(eo.getType().isFlyer() && !flyweapon) continue;
		if(!eo.getUnit()->isVisible()
			|| eo.getUnit()->getPosition() == BWAPI::Positions::None 
			|| eo.getUnit()->getPosition() == BWAPI::Positions::Invalid
			|| eo.getUnit()->getPosition() == BWAPI::Positions::Unknown) 
			continue;
		if(p.getApproxDistance(eo.getPosition()) + 800 < min_dis){
			min_dis = p.getApproxDistance(eo.getPosition()) + 800;
			min_unit = eo.getUnit();
		}
	}

	if(min_dis != DINF){
		last_target = min_unit;
		return min_unit;
	}
	return NULL;
}

void AttackerManager::createAttacker(BWAPI::Unit *unit){
	attackers.insert(AttackerData(unit));
}

void AttackerManager::removeAttacker(BWAPI::Unit *unit){
	AttackerData temp_attacker;
	BOOST_FOREACH(AttackerData a, attackers){
		if(a.getId() == unit->getID()) temp_attacker = a;
	}
	if(temp_attacker.getId() != -1){
		if(temp_attacker.getState() == AttackerState::Scout) CimexFlag::scout_flag = false;
		attackers.erase(temp_attacker);
	}
}

bool AttackerManager::simulateAttack(Corps &corpnum){
	//^[QbgȂAȂȂvZKvȂ
	return (corpnum.selfsimu < corpnum.enemysimu || corpnum.enemysimu == 0); //true͍UAfalse͓P
}


void AttackerManager::updateSimulateAttack(Corps &corpnum){
	//^[QbgȂAȂȂvZKvȂ
	if(corpnum.target != NULL && corpnum.target->isVisible()){
		double selfeval = 0, enemyeval = 0, selfdps = 0, enemydps = 0;
		bool enemy_airflag = false;
		if(corpnum.target->getType().isFlyer()) enemy_airflag = true;
		bool self_airflag  = false;
		if(corpnum.flyer) self_airflag = true;
		//O[v̌vZ
		////enemy

		int enemy_num = 0;
		BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(corpnum.target->getPosition(), corpnum.target->getType().sightRange())){
			if(u->getPlayer() == BWAPI::Broodwar->self() || !u->exists() || u->getType().isWorker()) continue;
			enemy_num++;
			if(u->getType() == BWAPI::UnitTypes::Terran_Bunker && u->isCompleted()){
				selfeval += u->getHitPoints() + u->getShields() + 100;
				BOOST_FOREACH(BWAPI::Unit* v, u->getLoadedUnits()){
					if(self_airflag){
						if(v->getType().airWeapon() == BWAPI::WeaponTypes::None || (u->getType().isBuilding() && !u->isCompleted())) continue;
						enemydps += (double)v->getType().airWeapon().damageAmount() / (double)v->getType().airWeapon().damageCooldown();
						selfeval += v->getHitPoints() + v->getShields();
					}else{
						if(v->getType().groundWeapon() == BWAPI::WeaponTypes::None || (u->getType().isBuilding() && !u->isCompleted())) continue;
						enemydps += (double)v->getType().groundWeapon().damageAmount() / (double)v->getType().groundWeapon().damageCooldown();
						selfeval += v->getHitPoints() + v->getShields();
					}
				}
			}else{ 
				if(self_airflag){
					if(u->getType().airWeapon() == BWAPI::WeaponTypes::None || (u->getType().isBuilding() && !u->isCompleted())) continue;
					enemydps += (double)u->getType().airWeapon().damageAmount() / (double)u->getType().airWeapon().damageCooldown();
					selfeval += u->getHitPoints() + u->getShields();
				}else{
					if(u->getType().groundWeapon() == BWAPI::WeaponTypes::None || (u->getType().isBuilding() && !u->isCompleted())) continue;
					enemydps += (double)u->getType().groundWeapon().damageAmount() / (double)u->getType().groundWeapon().damageCooldown();
					selfeval += u->getHitPoints() + u->getShields();
				}
			}
		}
		if(enemy_num <= 1) return; //G1̂ȂΒނ肩Ȃ
		////self
		for(std::set<AttackerData*>::iterator u = corpnum.corps.begin(); u != corpnum.corps.end(); u++){
			if(enemy_airflag){
				if((*u)->getType().airWeapon() == BWAPI::WeaponTypes::None) continue;
				selfdps += (double)(*u)->getType().airWeapon().damageAmount() / (double)(*u)->getType().airWeapon().damageCooldown();
				enemyeval += (*u)->getUnit()->getHitPoints() + (*u)->getUnit()->getShields();
			}else{
				if((*u)->getType().groundWeapon() == BWAPI::WeaponTypes::None) continue;
				if((*u)->getType() == BWAPI::UnitTypes::Zerg_Lurker) selfdps += ((double)(*u)->getType().groundWeapon().damageAmount() + 100) / (double)(*u)->getType().groundWeapon().damageCooldown();
				else selfdps += (double)(*u)->getType().groundWeapon().damageAmount() / (double)(*u)->getType().groundWeapon().damageCooldown();
				enemyeval += (*u)->getUnit()->getHitPoints() + (*u)->getUnit()->getShields();
			}
		}

		////
		if(enemydps != 0 && selfdps != 0){
			enemyeval = enemyeval / enemydps; //  HPv / DPSv = HP0ɂ܂ł̎ (ق)
			selfeval  = selfeval  / selfdps;
		}

		corpnum.selfsimu  = selfeval;
		corpnum.enemysimu = enemyeval;
	}

}

bool AttackerManager::inMyBase(int corpnum){
	if(attacker_corps[corpnum].target == NULL) return false;
	if(mapdata.getMybaseState(BWTA::getNearestBaseLocation(attacker_corps[corpnum].target->getPosition())) != -1){ //NearestBaseLocation is mybase
		if(attacker_corps[corpnum].target->getPosition().getApproxDistance(BWTA::getNearestBaseLocation(attacker_corps[corpnum].target->getPosition())->getPosition()) < attacker_corps[corpnum].target->getType().sightRange()
			|| attacker_corps[corpnum].target->getPosition().getApproxDistance(BWTA::getNearestBaseLocation(attacker_corps[corpnum].target->getPosition())->getPosition()) < attacker_corps[corpnum].target_position.getApproxDistance(BWTA::getNearestBaseLocation(attacker_corps[corpnum].target->getPosition())->getPosition())){
			return true;
		}
	}
	return false;
}

BWAPI::Position AttackerManager::getMutaliskPosition(){
	if(mapdata.getEnemybases().empty()) return BWAPI::Positions::None;
	BWTA::BaseLocation *now_b;
	if(mutalisk_corps.target_position != BWAPI::Positions::None) now_b = BWTA::getNearestBaseLocation(mutalisk_corps.target_position);
	else                                                         now_b = BWTA::getStartLocation(BWAPI::Broodwar->self());

	BOOST_FOREACH(ResourceData &r, resources){
		if(r.getState() != ResourceState::Enemy || now_b == BWTA::getNearestBaseLocation(r.getPosition())) continue;
		return r.getPosition();
	}
	BOOST_FOREACH(ResourceData &r, resources){
		if(r.getState() != ResourceState::None || now_b == BWTA::getNearestBaseLocation(r.getPosition())) continue;
		return r.getPosition();
	}
	return BWAPI::Positions::None;
}

BWAPI::Position AttackerManager::getDarkSwarmTP(AttackerData &a, BWAPI::Unit* target){
	if(a.getType() != BWAPI::UnitTypes::Zerg_Defiler) return BWAPI::Positions::None;
	if(target == NULL || !target->isVisible()) return BWAPI::Positions::None;
	if(a.getPosition().getApproxDistance(target->getPosition()) > target->getType().sightRange() * 2) return BWAPI::Positions::None;

	BWAPI::Unit* range_attacker = NULL;
	BOOST_FOREACH(BWAPI::Unit* u, target->getUnitsInRadius(target->getType().sightRange())){
		if(u->getPlayer() == BWAPI::Broodwar->self()) continue;
		if(u->getType().groundWeapon().maxRange() < 80) continue;
		range_attacker = u;
	}
	if(range_attacker == NULL) return BWAPI::Positions::None;


//܂łDefilerłȂAȂAARange AttackerȂ̂ɂNoneԂ

	int x1 = a.getUnit()->getTilePosition().x(),
		y1 = a.getUnit()->getTilePosition().y(),
		x2 = range_attacker->getTilePosition().x(),
		y2 = range_attacker->getTilePosition().y();

	//out4 << BWAPI::Broodwar->getFrameCount() << std::endl;
	//out4 << x1 << "," << y1 << std::endl;
	//out4 << x2 << "," << y2 << std::endl;
	//out4 << a.getPosition().getApproxDistance(target->getPosition()) << std::endl;
	//out4 << target->getType().sightRange() << std::endl;


	double dvecx = x2 -x1;
	double dvecy = y2 -y1;
	int vecx, vecy;
	if(fabs(dvecx) <= fabs(dvecy)){
		vecx = ceil(dvecx / fabs(dvecx)) * 3;
		vecy = ceil(dvecy / fabs(dvecx)) * 3;
	}else{
		vecx = ceil(dvecx / fabs(dvecy)) * 3;
		vecy = ceil(dvecy / fabs(dvecy)) * 3;
	}

	//out4 << dvecx << "," << dvecy << std::endl;
	//out4 << vecx << "," << vecy << std::endl;


	int x = x1, y = y1;
	x2 = x2 + vecx;
	y2 = y2 + vecy;
	//out4 << x2 << "," << y2 << std::endl;
	//out4 << std::endl << std::endl;
	if(vecx < 0){
		if(vecy < 0){//-,-
			while(x >= x2 && y >= y2){
				bool flag = true;
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsOnTile(x, y)){
					if(u == NULL || !u->exists() || !u->getPlayer()->isNeutral()) continue;
					if(u->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm){
						flag = false;
						break;
					}
				}
				if(flag) return BWAPI::Position(x * TILE_SIZE,y * TILE_SIZE);
				x += vecx;
				y += vecy;
			}
		}else{//-,+
			while(x >= x2 && y <= y2){
				bool flag = true;
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsOnTile(x, y)){
					if(u == NULL || !u->exists() || !u->getPlayer()->isNeutral()) continue;
					if(u->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm){
						flag = false;
						break;
					}
				}
				if(flag) return BWAPI::Position(x * TILE_SIZE,y * TILE_SIZE);
				x += vecx;
				y += vecy;
			}
		}
	}else{
		if(vecy < 0){//+,-
			while(x <= x2 && y >= y2){
				bool flag = true;
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsOnTile(x, y)){
					if(u == NULL || !u->exists() || !u->getPlayer()->isNeutral()) continue;
					if(u->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm){
						flag = false;
						break;
					}
				}
				if(flag) return BWAPI::Position(x * TILE_SIZE,y * TILE_SIZE);
				x += vecx;
				y += vecy;
			}
		}else{//+,+
			while(x <= x2 && y <= y2){
				bool flag = true;
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsOnTile(x, y)){
					if(u == NULL || !u->exists() || !u->getPlayer()->isNeutral()) continue;
					if(u->getType() == BWAPI::UnitTypes::Spell_Dark_Swarm){
						flag = false;
						break;
					}
				}
				if(flag) return BWAPI::Position(x * TILE_SIZE,y * TILE_SIZE);
				x += vecx;
				y += vecy;
			}
		}
	}

	//out4 << "no" << std::endl << std::endl << std::endl;
	return BWAPI::Positions::None;
}