#pragma once
#include "UnitManager.h"
#include "Const.h"
#include <math.h>

class AttackerManager : public UnitManager
{
private:
	struct Corps{
		std::set<AttackerData*> corps;
		double selfsimu;
		double enemysimu;
		BWAPI::Unit* target;
		int state;
		BWAPI::Position target_position;
		bool flyweapon;
		bool flyer;
	};

	struct AttackerNum{
		int attacker_num;
		int zergling_num;
		int hydralisk_num;
		int lurker_num;
		int mutalisk_num;
		int scourge_num;
		int defiler_num;
	};

	std::vector<Corps> attacker_corps;
	Corps mutalisk_corps;
	std::set<AttackerData*> morph_corps;
	int morph_mutalisk;
	int morph_hydralisk;

	AttackerNum pre_attackernum;
	double enemy_simulate_min;
	BWAPI::Unit *last_target;
	int now_state;
	double enemy_hp;

	bool trampled_muta; //Wǂ

	int scout_index;

public:

	AttackerManager(void);

	~AttackerManager(void);

	void update();

	void initAttackerNum(AttackerNum *an);

	bool updateAttackerNum();

	void updateCorps(AttackerNum *all_num);

	void attack(AttackerData &a, bool first);

	void attack(AttackerData &a, BWAPI::Position p, bool first);

	bool morph(BWAPI::UnitType type);

	void updateMorphNum(int hydralisk_num, int mutalisk_num);

	BWAPI::Unit* changeTarget(BWAPI::Position p, bool flyweapon, bool flyer);

	void createAttacker(BWAPI::Unit *unit);

	void removeAttacker(BWAPI::Unit *unit);

	bool simulateAttack(Corps &corpnum);

	void updateSimulateAttack(Corps &corpnum);

	bool inMyBase(int corpnum);

	BWAPI::Position getMutaliskPosition();

	BWAPI::Position getDarkSwarmTP(AttackerData &a, BWAPI::Unit* target);

};

