#include "Const.h"

namespace AttackerState {
	const int None    = 0;
	const int Attack  = 1;
	const int Retreat = 2;
	const int Defense = 3;
	const int Scout   = 4;
	const int Max     = 5;
}

namespace WorkerState {
	const int None    = 0;
	const int Mineral = 1;
	const int Gas     = 2;
	const int Build   = 3;
	const int Attack  = 4;
	const int Max     = 5;
}

namespace BuildingState {
	const int None         = 0;
	const int Execute      = 1;
	const int Constructing = 2;
	const int Completed    = 3;
	const int Max          = 4;
}

namespace OtherUnitState{
	const int None     = 0;
	const int Scout    = 1;
	const int Detect   = 2;
	const int Max      = 3;
}

namespace ResourceState{
	const int None  = 0;
	const int Mine  = 1;
	const int Enemy = 2;
	const int Max   = 3;
}

namespace MyBaseProductState{
	const int Worker   = 0;
	const int Attacker = 1;
	const int Max      = 2;
}

namespace BuildOrderType{
	//Unit
	const int Brooding            = 0; 
	const int Defiler             = 1;
	const int Hydralisk           = 2;
	const int Lurker              = 3;
	const int Ultralisk           = 4;
	const int Zergling            = 5;
	const int Devourer            = 6;
	const int Guardian            = 7;
	const int Mutalisk            = 8;
	const int Overload            = 9;
	const int Queen               = 10;
	const int Scourge             = 11;
	//Building
	const int CreepColony         = 12; 
	const int DefilerMound        = 13;
	const int EvolutionChamber    = 14;
	const int Extractor           = 15;
	const int GreaterSpire        = 16;
	const int Hatchery            = 17;
	const int Hive                = 18;
	const int HydraliskDen        = 19;
	const int Lair                = 20;
	const int NydusCanel          = 21;
	const int QueensNest          = 22;
	const int SpawningPool        = 23;
	const int Spire               = 24;
	const int SporeColony         = 25;
	const int SunkenColony        = 26;
	const int UltraliskCavern     = 27;
	//Upgrade
	const int Carapace            = 28;
	const int MeleeAtack          = 29;
	const int MetasynapticNode    = 30; //defiler: max energy + 50
	const int MissileAttacks      = 31;
	const int MuscularAugment     = 32; //hydralisk: speed up
	const int GroovedSpines       = 33; //hydralisk: attack range up
	const int ChitinousPlating    = 34; //ultralisk: armor up
	const int AnabolicSynthesis   = 35; //ultralisk: speed up
	const int MetabolicBoost      = 36; //zergling: speed up
	const int AdrenalGlands       = 37; //zergling attack rate up
	const int FlyerCarapace       = 38;
	const int FlyerAttacks        = 39;
	const int VentralSacs         = 40; //overload: transport unit
	const int Antennae            = 41; //overload: sight range up
	const int PneumatizedCarapace = 42; //overload: speed up
	const int GameteMeiosis       = 43; //queen
	//Tech
	const int Burrowing           = 44;
	const int DarkSwarm           = 45; //defiler: defense range attack 6*6
	const int Plague              = 46; //defiler: 25 damege per second
	const int Consume             = 47; //defiler: kill my zerg unit and charge 50 E
	const int LurkerAspect        = 48;
	const int Infestation         = 49; //queen
	const int SpawnBroodings      = 50; //queen
	const int Ensnare             = 51; //queen
	const int Parasite            = 52;
	const int Base                = 53;
	const int Max                 = 54;
}

namespace CimexFlag{
	bool scout_flag = false; //Scout݂Ă邩
	bool next_mybase_flag = false;; //̊n낤Ƃworker邩
	bool enemy_air_weapon = false; //G΋󕺊Ă邩ǂ
	bool no_resource_flag = false;
}


namespace BuildOrderData{
	int drone_num = 0;
	int hold_num[54];
	int build_order_index = 0;
}



std::set<WorkerData> workers;
std::set<AttackerData> attackers;
std::set<BuildingData> buildings;
std::set<ResourceData> resources;
std::set<LarvaData> larvas;
std::set<OtherUnitData> others;
MapData mapdata;
PlayerData playerdata;

std::set<WorkerData> eworkers;
std::set<AttackerData> eattackers;
std::set<BuildingData> ebuildings;
std::set<OtherUnitData> eothers;
std::set<int> epre_id;

//debug
std::ofstream out;
std::ofstream out2;
std::ofstream out3;
std::ofstream out4;
std::ofstream build_order_out;

//strategy
std::ifstream gbo_in;
std::ofstream gbo_out;
bool gbotx_er = false;
int strategy_num = 0;
int winning_streak = 0;


//\
const int timex1 = 480;
const int timex2 = 600;

const int DINF = 10000000; //̍ő
const int dx[8] = {-1, -1,  0,  1, 1, 1, 0, -1}; //8p
const int dy[8] = { 0, -1, -1, -1, 0, 1, 1,  1};

const bool logging_flag = false;
const bool logging_flag2 = false;
const bool build_order_log = false;



BWAPI::Position ppp; //debugp@SpyɌ~Ŏ
BWTA::BaseLocation* temp_next_mybase; //next_mybase甲ꂽBaseꎞIɕۑ
int build_order[102][54];
//build_order_t build_order[102];
/*build_order_t build_order[102] = {
	{ 0, 0, 0, 0,  0 ,   0 }, //   0
	{ 1, 1, 0, 0,  1 ,   0 }, //   1
	{ 1, 1, 0, 0,  1 ,   0 }, //   2
	{ 1, 1, 0, 0,  1 ,   0 }, //   3
	{ 1, 1, 0, 0,  1 ,   0 }, //   4
	{ 1, 1, 0, 0,  1 ,   0 }, //   5
	{ 1, 1, 0, 0,  1 ,   0 }, //   6
	{ 1, 1, 1, 0,  1 ,   0 }, //   7
	{ 1, 1, 1, 0,  2 ,   6 }, //   8
	{ 2, 2, 1, 0,  2 ,   8 }, //   9
	{ 2, 2, 1, 0,  2 ,   8 }, //  10
	{ 2, 3, 1, 1,  2 ,   8 }, //  11
	{ 2, 3, 1, 1,  3 ,   8 }, //  12
	{ 3, 4, 1, 1,  4 ,  12 }, //  13
	{ 3, 4, 1, 1,  4 ,  14 }, //  14
	{ 3, 4, 1, 1,  4 ,  14 }, //  15
	{ 3, 5, 1, 1,  5 ,  16 }, //  16
	{ 3, 5, 1, 1,  5 ,  16 }, //  17
	{ 3, 5, 1, 1,  5 ,  18 }, //  18
	{ 3, 6, 1, 1,  5 ,  18 }, //  19
	{ 3, 6, 1, 1,  6 ,  20 }, //  20
	{ 3, 6, 1, 1,  6 ,  20 }, //  21
	{ 3, 6, 1, 1,  6 ,  22 }, //  22
	{ 3, 6, 1, 1,  6 ,  22 }, //  23
	{ 4, 7, 1, 1,  7 ,  24 }, //  24
	{ 4, 7, 1, 1,  7 ,  24 }, //  25
	{ 4, 7, 1, 1,  7 ,  26 }, //  26
	{ 4, 7, 1, 1,  7 ,  26 }, //  27
	{ 4, 7, 1, 1,  8 ,  28 }, //  28
	{ 4, 7, 1, 1,  8 ,  28 }, //  29
	{ 4, 7, 1, 1,  8 ,  30 }, //  30
	{ 4, 7, 1, 1,  8 ,  30 }, //  31
	{ 4, 7, 1, 1,  9 ,  32 }, //  32
	{ 4, 7, 1, 1,  9 ,  32 }, //  33
	{ 4, 7, 1, 1,  9 ,  34 }, //  34
	{ 4, 7, 1, 1,  9 ,  34 }, //  35
	{ 4, 7, 1, 1, 10 ,  36 }, //  36
	{ 4, 7, 1, 1, 10 ,  36 }, //  37
	{ 4, 7, 1, 1, 10 ,  38 }, //  38
	{ 4, 7, 1, 1, 10 ,  38 }, //  39
	{ 4, 7, 1, 1, 11 ,  40 }, //  40
	{ 4, 7, 1, 1, 11 ,  40 }, //  41
	{ 4, 7, 1, 1, 11 ,  42 }, //  42
	{ 4, 7, 1, 1, 11 ,  42 }, //  43
	{ 4, 7, 1, 1, 12 ,  44 }, //  44
	{ 4, 7, 1, 1, 12 ,  44 }, //  45
	{ 4, 7, 1, 1, 12 ,  46 }, //  46
	{ 4, 7, 1, 1, 12 ,  46 }, //  47
	{ 4, 7, 1, 1, 13 ,  48 }, //  48
	{ 4, 7, 1, 1, 13 ,  48 }, //  49
	{ 4, 7, 1, 1, 13 ,  50 }, //  50
	{ 4, 7, 1, 1, 13 ,  50 }, //  51
	{ 4, 7, 1, 1, 14 ,  56 }, //  52
	{ 4, 7, 1, 1, 14 ,  62 }, //  53
	{ 4, 7, 1, 1, 14 ,  68 }, //  54
	{ 4, 7, 1, 1, 14 ,  74 }, //  55
	{ 4, 7, 1, 1, 15 ,  80 }, //  56
	{ 4, 7, 1, 1, 15 ,  86 }, //  57
	{ 4, 7, 1, 1, 15 ,  92 }, //  58
	{ 4, 7, 1, 1, 15 ,  98 }, //  59
	{ 4, 7, 1, 1, 16 , 104 }, //  60
	{ 4, 7, 1, 1, 16 , 110 }, //  61
	{ 4, 7, 1, 1, 16 , 116 }, //  62
	{ 4, 7, 1, 1, 16 , 122 }, //  63
	{ 4, 7, 1, 1, 17 , 128 }, //  64
	{ 4, 7, 1, 1, 17 , 130 }, //  65
	{ 4, 7, 1, 1, 17 , 132 }, //  66
	{ 4, 7, 1, 1, 17 , 134 }, //  67
	{ 4, 7, 1, 1, 18 , 136 }, //  68
	{ 4, 7, 1, 1, 18 , 138 }, //  69
	{ 4, 7, 1, 1, 18 , 140 }, //  70
	{ 4, 7, 1, 1, 18 , 142 }, //  71
	{ 4, 7, 1, 1, 19 , 144 }, //  72
	{ 4, 7, 1, 1, 19 , 146 }, //  73
	{ 4, 7, 1, 1, 19 , 148 }, //  74
	{ 4, 7, 1, 1, 19 , 150 }, //  75
	{ 4, 7, 1, 1, 20 , 152 }, //  76
	{ 4, 7, 1, 1, 20 , 154 }, //  77
	{ 4, 7, 1, 1, 20 , 156 }, //  78
	{ 4, 7, 1, 1, 20 , 158 }, //  79
	{ 4, 7, 1, 1, 21 , 160 }, //  80
	{ 4, 7, 1, 1, 21 , 162 }, //  81
	{ 4, 7, 1, 1, 21 , 164 }, //  82
	{ 4, 7, 1, 1, 21 , 166 }, //  83
	{ 4, 7, 1, 1, 22 , 168 }, //  84
	{ 4, 7, 1, 1, 22 , 170 }, //  85
	{ 4, 7, 1, 1, 22 , 172 }, //  86
	{ 4, 7, 1, 1, 22 , 174 }, //  87
	{ 4, 7, 1, 1, 23 , 176 }, //  88
	{ 4, 7, 1, 1, 23 , 178 }, //  89
	{ 4, 7, 1, 1, 23 , 180 }, //  90
	{ 4, 7, 1, 1, 23 , 182 }, //  91
	{ 4, 7, 1, 1, 24 , 184 }, //  92
	{ 4, 7, 1, 1, 24 , 186 }, //  93
	{ 4, 7, 1, 1, 24 , 188 }, //  94
	{ 4, 7, 1, 1, 24 , 190 }, //  95
	{ 4, 7, 1, 1, 25 , 192 }, //  96
	{ 4, 7, 1, 1, 25 , 194 }, //  97
	{ 4, 7, 1, 1, 25 , 196 }, //  98
	{ 4, 7, 1, 1, 25 , 198 }, //  99
	{ 4, 7, 1, 1, 25 , 200 }, //  100
	{ 4, 7, 1, 1, 25 , 2000 }  //  avoid errors
};*/
