#include "EnemyDataManager.h"


EnemyDataManager::EnemyDataManager(void)
{
}


EnemyDataManager::~EnemyDataManager(void)
{
}


void EnemyDataManager::createUnit(){
	BOOST_FOREACH(BWAPI::Unit * u, BWAPI::Broodwar->enemy()->getUnits()){
		if( ! u->exists() ) continue;
		if( epre_id.find(u->getID()) != epre_id.end() )  continue;

		epre_id.insert(u->getID());

		if(logging_flag) out << "a" << std::endl;
		if(u->getType().isWorker()){
			if(logging_flag) out << "b" << std::endl;
			eworkers.insert(WorkerData(u));
		}else if(u->getType().groundWeapon() != BWAPI::WeaponTypes::None || u->getType().airWeapon() != BWAPI::WeaponTypes::None || u->getType() == BWAPI::UnitTypes::Terran_Bunker){
			if(logging_flag) out << "c" << std::endl;
			if(u->getType().airWeapon() != BWAPI::WeaponTypes::None) CimexFlag::enemy_air_weapon = true;
			eattackers.insert(AttackerData(u));
		}else if(u->getType().isBuilding()){
			if(logging_flag) out << "d" << std::endl;
			ebuildings.insert(BuildingData(u));
			if(logging_flag) out << "d-1" << std::endl;
			mapdata.setEnemybases(BWTA::getNearestBaseLocation(u->getPosition()));
		}else {
			if(logging_flag) out << "e" << std::endl;
			eothers.insert(OtherUnitData(u));
		}
	}
}

void EnemyDataManager::removeUnit(){
	std::vector<WorkerData> erase_workers;
	std::vector<AttackerData> erase_attackers;
	std::vector<BuildingData> erase_buildings;
	std::vector<OtherUnitData> erase_others;

	////worker
	if(logging_flag) out << "4-1,"<< std::endl;
	for(std::set<WorkerData>::iterator w = eworkers.begin(); w != eworkers.end(); w++){
		if((*w).getUnit() == NULL || (!(*w).getUnit()->exists() || (*w).getType() != (*w).getUnit()->getType()) && (*w).getUnit()->isVisible()){
			erase_workers.push_back(*w);
			epre_id.erase((*w).getId());
		}
	}
	BOOST_FOREACH(WorkerData &w, erase_workers){
		BOOST_FOREACH(AttackerData &a, attackers){
			if(a.getTarget() == w.getUnit()) a.setTarget(NULL);
		}
		eworkers.erase(w);
	}
	erase_workers.clear();

	////attacker
	if(logging_flag) out << "4-2,"<< std::endl;
	for(std::set<AttackerData>::iterator a = eattackers.begin(); a != eattackers.end(); a++){
		if((*a).getUnit() == NULL || (!(*a).getUnit()->exists() || (*a).getType() != (*a).getUnit()->getType()) && (*a).getUnit()->isVisible()){
			erase_attackers.push_back(*a);
			epre_id.erase((*a).getId());
		}
	}
	BOOST_FOREACH(AttackerData &a, erase_attackers){
		BOOST_FOREACH(AttackerData &sa, attackers){
			if(sa.getTarget() == a.getUnit()) sa.setTarget(NULL);
		}
		eattackers.erase(a);
	}
	erase_attackers.clear();

	////building
	if(logging_flag) out << "4-3" << std::endl;
	for(std::set<BuildingData>::iterator b = ebuildings.begin(); b != ebuildings.end(); b++){
		if((*b).getUnit() == NULL || (!(*b).getUnit()->exists() || (*b).getType() != (*b).getUnit()->getType()) && (*b).getUnit()->isVisible()){
			erase_buildings.push_back(*b);
			epre_id.erase((*b).getId());
		}
	}
	if(logging_flag) out << "check"<< std::endl;
	if(!erase_buildings.empty()){
		BOOST_FOREACH(BuildingData &b, erase_buildings){
			if(logging_flag) out << "1"<< std::endl;
			if(logging_flag) out << &b << std::endl;
			if(logging_flag) out << b.getType().c_str() << std::endl;
			if(logging_flag) out << BWAPI::Broodwar->enemy()->getRace().getCenter().c_str() << std::endl;
			if(logging_flag) out << b.getPosition() << std::endl;
			if(logging_flag) out << "2"<< std::endl;
			BOOST_FOREACH(AttackerData &a, attackers){
				if(a.getTarget() == b.getUnit()) a.setTarget(NULL);
			}
			ebuildings.erase(b);
		}
	}
	erase_buildings.clear();

	////other
	if(logging_flag) out << "4-4,"<< std::endl;
	for(std::set<OtherUnitData>::iterator o = eothers.begin(); o != eothers.end(); o++){
		if((*o).getUnit() == NULL || (!(*o).getUnit()->exists() || (*o).getType() != (*o).getUnit()->getType()) && (*o).getUnit()->isVisible()){
			erase_others.push_back(*o);
			epre_id.erase((*o).getId());
		}
	}
	BOOST_FOREACH(OtherUnitData &o, erase_others){
		BOOST_FOREACH(AttackerData &a, attackers){
				if(a.getTarget() == o.getUnit()) a.setTarget(NULL);
			}
		eothers.erase(o);
	}
	erase_others.clear();
}