#include "ResourceData.h"

ResourceData::ResourceData() : 
	assigned_num(-1),
	state(ResourceState::None)
{}

ResourceData::~ResourceData(void){}

ResourceData::ResourceData(BWAPI::Unit * u) : 
	UnitData(u),
	remnant(u->getResources()),
	assigned_num(0),
	tposition(u->getTilePosition()),
	state(ResourceState::None),
	stolenflag(false)
{
	tsize[0] = getType().tileWidth();
	tsize[1] = getType().tileHeight();
}

void ResourceData::update(){
	/*std::ofstream rout("resource.txt", std::ios_base::binary | std::ios_base::out | std::ios_base::trunc);
	if (!rout) {
		std::cout << "***error  o̓t@CJ܂\n";
		exit(1);
		}*/
	unit_update();
	//if(getType().isRefinery() && state == ResourceState::Mine) BWAPI::Broodwar->drawCircleMap(getPosition().x(), getPosition().y(), 70, BWAPI::Colors::Red);
	//if(getType() == BWAPI::UnitTypes::Resource_Vespene_Geyser && state == ResourceState::Mine) BWAPI::Broodwar->drawCircleMap(getPosition().x(), getPosition().y(), 70, BWAPI::Colors::Blue);
	//if(stolenflag) BWAPI::Broodwar->drawCircleMap(getPosition().x(), getPosition().y(), 70, BWAPI::Colors::Yellow);

	//GRefinery΍
	if(state == ResourceState::Mine && getUnit()->getPlayer() == BWAPI::Broodwar->self()){
		stolenflag = false;
	}
	if(stolenflag && getUnit()->getPlayer() != BWAPI::Broodwar->enemy()){
		setState(ResourceState::Mine);
	}
	if(state == ResourceState::Mine && getUnit()->getPlayer() == BWAPI::Broodwar->enemy()){
		setState(ResourceState::Enemy);
		stolenflag = true;
	}

	if(getUnit()->isVisible()){
		remnant = getUnit()->getResources();
		tposition = getUnit()->getTilePosition();

		/*if(getType() == BWAPI::UnitTypes::Resource_Vespene_Geyser && getUnit()->getType().isRefinery())      setType(getUnit()->getType());
		else if(getUnit()->getType() == BWAPI::UnitTypes::Resource_Vespene_Geyser && getType().isRefinery())*/ setType(getUnit()->getType());
		//rout << mapdata.get_mapwidth() << "," << mapdata.get_mapheight() << std::endl;
		//̎3Tilebuilding֎~
		if(getState() == ResourceState::Mine){
			for(int i = tposition.x() - 3; i < tposition.x() + tsize[0] + 3; i++){
				//rout << "i = " << i << std::endl;
				if(i >= mapdata.getMapwidth() || i < 0) continue;
				for(int j = tposition.y() - 3; j < tposition.y() + tsize[1] + 3; j++){
					//rout << "j = " << j << std::endl;
					if(j >= mapdata.getMapheight() || j < 0) continue;
					mapdata.setBuildableMap(i,j,false);
					//BWAPI::Broodwar->drawDotMap(i*TILE_SIZE, j*TILE_SIZE, BWAPI::Colors::Red);
				}
			}
		}
	}

}

int ResourceData::getRemnant() const
{ return remnant;}

int ResourceData::getAssignedNum() const { return assigned_num;}

int ResourceData::getState() const { return state;}

BWAPI::TilePosition ResourceData::getTposition() const
{ return tposition;}

char * ResourceData::getStateChar() const
{
	if(state == 0) return "None";
	else if(state == 1) return "Mine";
	else if(state == 2) return "Enemy";
	else return "????";
}


void ResourceData::subAssigned(){ assigned_num--;}

void ResourceData::addAssigned(){ assigned_num++;}

void ResourceData::setState(const int &i){
	if(i >= ResourceState::Max) return;
	state = i;
	return;
}