#include "WorkerData.h"

WorkerData::WorkerData(BWAPI::Unit * u) : 
	UnitData(u),
	state(WorkerState::None),
	target(NULL),
	building(NULL),
	move_to_tp(BWAPI::TilePositions::None)
{
	now_location = BWTA::getNearestBaseLocation(getPosition());
}

WorkerData::WorkerData() : 
	UnitData(),
	state(WorkerState::None),
	target(NULL),
	building(NULL),
	move_to_tp(BWAPI::TilePositions::None)
{
}

WorkerData::~WorkerData(void)
{
}

void WorkerData::update(){
	unit_update();
	hp = getUnit()->getHitPoints();

	if(state == WorkerState::None){
		//if(logging_flag) out << "n,"<< std::endl;
		if(getUnit()->getType().isWorker()){
			bool gas_flag = false;
			BOOST_FOREACH(ResourceData &r, resources){
				if(&r == NULL 
					|| r.getUnit() == NULL 
					|| !r.getType().isRefinery() 
					|| !r.getUnit()->isCompleted() 
					|| r.getAssignedNum() >= 3 
					|| r.getState() != ResourceState::Mine
					|| BWTA::getRegion(getPosition()) != BWTA::getRegion(r.getPosition()))
					continue;

				gas_flag = true;
				target = &r;
				r.addAssigned();
				break;
			}
			
			//ʂRegionh
			if(!gas_flag){
				BOOST_FOREACH(ResourceData &r, resources){
					if(&r == NULL 
						|| r.getUnit() == NULL 
						|| !r.getType().isRefinery() 
						|| !r.getUnit()->isCompleted() 
						|| r.getState() != ResourceState::Mine
						|| r.getAssignedNum() >= 3 )
						continue;

					gas_flag = true;
					target = &r;
					r.addAssigned();
					break;
				}
			}
			if(gas_flag)
				state = WorkerState::Gas;
			else
				state = WorkerState::Mineral;
		}
	}else if(state == WorkerState::Mineral){
		//if(logging_flag) out << "m,"<< std::endl;

	}else if(WorkerState::Build){
		//if(logging_flag) out << "b,"<< std::endl;
		if(move_to_tp != BWAPI::TilePositions::None && building != NULL){
			//if(logging_flag) out << "b-1,"<< std::endl;
			//if(logging_flag) out << building.getName().c_str() << std::endl;
			//if(logging_flag) out << move_to_tp.x() << "," << move_to_tp.y() << std::endl;
			for(int i = move_to_tp.x(); i < move_to_tp.x() + building.tileWidth(); i++){
				for(int j = move_to_tp.y(); j < move_to_tp.y() + building.tileHeight(); j++){
					//if(logging_flag) out << i << "," << j << std::endl;
					mapdata.setBuildableMap(i,j,false);
				}
			}
		}
	}
}

void WorkerData::eupdate(){
	if(getUnit()->isVisible()){
		unit_update();
		hp = getUnit()->getHitPoints();
	}
}

char * WorkerData::getStateChar(){
	if(state == 0) return "None";
	else if(state == 1) return "Mineral";
	else if(state == 2) return "Gas";
	else if(state == 3) return "Build";
	else if(state == 4) return "Attack";
	else return "????";
}

int WorkerData::getState() const
{ return state;}

int WorkerData::getHp() const
{ return hp;}

ResourceData * WorkerData::getTarget() const
{ return target;}

BWAPI::UnitType WorkerData::getBuilding() const
{ return building;}


BWTA::BaseLocation* WorkerData::getNowLocation() const
{ return now_location;}


BWAPI::TilePosition WorkerData::getMovetoTp() const
{ return move_to_tp;}


void WorkerData::setNowLocation(BWTA::BaseLocation* b){
	now_location = b;
}


void WorkerData::setTarget(ResourceData &u){
	target = &u;
}

void WorkerData::clearTarget(){
	target = NULL;
}

void WorkerData::setState(const int &i){
	if(i >= WorkerState::Max) return;
	state = i;
	return;
}

void WorkerData::setMovetoTp(BWAPI::TilePosition tp){
	if(building != NULL){
		for(int i = tp.x(); i < tp.x() + building.tileWidth(); i++){
			for(int j = tp.y(); j < tp.y() + building.tileHeight(); j++){
				mapdata.setBuildableMap(i,j,false);
				//BWAPI::Broodwar->drawDotMap(i*TILE_SIZE, j*TILE_SIZE, BWAPI::Colors::Red);
			}
		}
	}
	move_to_tp = tp;
}

void WorkerData::setBuilding(BWAPI::UnitType type){
	building = type;
}