#include "WorkerManager.h"


WorkerManager::WorkerManager(void) :
	build_flag(0)
{
}


WorkerManager::~WorkerManager(void)
{
}

void WorkerManager::update(){
	CimexFlag::no_resource_flag = true;
	BOOST_FOREACH(ResourceData &r, resources){
		if(&r == NULL || r.getUnit() == NULL || !r.getType().isMineralField() || r.getRemnant() <= 0 || !r.getUnit()->exists()) continue;
		CimexFlag::no_resource_flag = false;
	}
	/*if(!workers.empty()) 
		BOOST_FOREACH(WorkerData &w, workers) w.update();*/

	if(!workers.empty()){
		if(logging_flag) out3 << workers.size() << std::endl;
		BOOST_FOREACH(WorkerData &w, workers){
			if(&w == NULL || w.getUnit() == NULL || w.getState() == NULL) continue;
			//MineralFł߂ɂmineral
			if(w.getState() == WorkerState::Mineral){
				if(logging_flag) out3 << "m" << std::endl;
				if(CimexFlag::no_resource_flag){
					if(logging_flag) out3 << "m-1" << std::endl;
					w.getUnit()->stop();
					if(w.getTarget() != NULL) w.clearTarget();
					continue;
				}
				if(w.getTarget() != NULL && w.getTarget()->getAssignedNum() > -1 && w.getTarget()->getUnit() != NULL && w.getTarget()->getUnit()->getType().isMineralField()){
					if(logging_flag) out3 << "m-2" << std::endl;
					if(!w.getUnit()->isGatheringMinerals()){
						if(logging_flag) out3 << "m-3" << std::endl;
						w.getUnit()->gather(w.getTarget()->getUnit());
					}
				}else{
					if(logging_flag) out3 << "m-4" << std::endl;
					int min_dis = DINF, min_ass = 100;
					ResourceData *min_r = NULL;
					BOOST_FOREACH(ResourceData &r, resources){
						if(&r == NULL || r.getUnit() == NULL || !r.getType().isMineralField() || r.getRemnant() <= 0 || !r.getUnit()->exists() || r.getState() != ResourceState::Mine) continue;
						if(min_ass > r.getAssignedNum()){
							min_ass = r.getAssignedNum();
							min_dis = (int)w.getUnit()->getDistance(r.getPosition());
							min_r = &r;
						}else if(min_ass == r.getAssignedNum()){
							if(min_dis > (int)w.getUnit()->getDistance(r.getPosition())){
								min_dis = (int)w.getUnit()->getDistance(r.getPosition());
								min_r = &r;
							}
						}
					}					
					if(logging_flag) out3 << "m-5" << std::endl;
					//ȂȂNonełǂ
					if(min_r == NULL || min_r->getUnit() == NULL || w.getTarget() == min_r || min_r->getAssignedNum() < 0){
						min_dis = DINF;
						min_ass = 100;
						BOOST_FOREACH(ResourceData &r, resources){
							if(&r == NULL || r.getUnit() == NULL || !r.getType().isMineralField() || r.getRemnant() <= 0 || !r.getUnit()->exists() || r.getState() != ResourceState::None) continue;
							if(min_ass > r.getAssignedNum()){
								min_ass = r.getAssignedNum();
								min_dis = (int)w.getUnit()->getDistance(r.getPosition());
								min_r = &r;
							}else if(min_ass == r.getAssignedNum()){
								if(min_dis > (int)w.getUnit()->getDistance(r.getPosition())){
									min_dis = (int)w.getUnit()->getDistance(r.getPosition());
									min_r = &r;
								}
							}
						}
						if(logging_flag) out3 << "m-6" << std::endl;
						if(min_r == NULL || min_r->getUnit() == NULL || w.getTarget() == min_r || min_r->getAssignedNum() < 0) continue;
					}

					if(w.getTarget() != NULL) w.getTarget()->subAssigned();
					w.setTarget(*min_r);
					min_r->addAssigned();
					w.setNowLocation(BWTA::getNearestBaseLocation(min_r->getPosition()));
					if(logging_flag) out3 << "m-7" << std::endl;
				}
				//Gas
			}else if(w.getState() == WorkerState::Gas){
				if(logging_flag) out3 << "g" << std::endl;
				//if(logging_flag) out3 << w.getTarget() << std::endl;
				//if(logging_flag) out3 << w.getTarget()->getUnit() << std::endl;
				//if(logging_flag) out3 << w.getTarget()->getUnit()->isVisible() << std::endl; 
				if(w.getTarget() != NULL && w.getTarget()->getUnit() != NULL /*&& w.getTarget()->getUnit()->isVisible()/*&& w.getTarget()->getUnit()->getResources() > 0*/){
					if(logging_flag) out3 << "g-1" << std::endl;
					if(!w.getUnit()->isGatheringGas()) w.getUnit()->gather(w.getTarget()->getUnit());
				}else{
					if(logging_flag) out3 << "g-2" << std::endl;
					BOOST_FOREACH(ResourceData &r, resources){
						if(r.getType().isRefinery() && r.getUnit()->isCompleted() && r.getAssignedNum() < 3 && BWTA::getRegion(w.getPosition()) == BWTA::getRegion(r.getPosition()) && r.getState() == ResourceState::Mine
							&& r.getUnit()->getPlayer() == BWAPI::Broodwar->self()){
							w.setTarget(r);
							r.addAssigned();
						}
					}
					if(logging_flag) out3 << "g-3" << std::endl;
					if(w.getTarget() == NULL){
						BOOST_FOREACH(ResourceData &r, resources){
							if(r.getType().isRefinery() && r.getUnit()->isCompleted() && r.getAssignedNum() < 3 && r.getState() == ResourceState::Mine && r.getUnit()->getPlayer() == BWAPI::Broodwar->self()){
								w.setTarget(r);
								r.addAssigned();
							}
						}
					}
					if(logging_flag) out3 << "g-4" << std::endl;
				}

				//Build
			}else if(w.getState() == WorkerState::Build){
				if(logging_flag) out3 << "b" << std::endl;
				if(w.getMovetoTp() != NULL && w.getMovetoTp() != BWAPI::TilePositions::None && w.getMovetoTp().isValid()){  //ɌĂƂw肳Ă
					build(w);
				}else{
					w.setState(WorkerState::None);
				}
			}else{
			}

			BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(w.getPosition(), 32)){
				if(u->getPlayer() != BWAPI::Broodwar->enemy()) continue;
				//GRjbgȂ
				w.getUnit()->attack(u);
			}
		}
	}
}

bool WorkerManager::canBuild(BWAPI::UnitType type){
	BOOST_FOREACH(WorkerData &w, workers){
		if(w.getState() == WorkerState::Mineral){
			if(w.getNowLocation() != NULL){
				if(w.getTarget() != NULL ) w.getTarget()->subAssigned();
				w.clearTarget();
				w.setState(WorkerState::Build);
				w.setBuilding(type);
			}else continue;
		}else continue;
		if(type != BWAPI::UnitTypes::Zerg_Creep_Colony){
			if(!type.isRefinery()){
				//hatcheryŎ̊nĂ鎞Ȃ
				bool new_flag = false;
				if(w.getBuilding().isResourceDepot()){
					bool as_flag = false;
					if(build_order[BuildOrderData::build_order_index][BuildOrderType::Base] - BuildOrderData::hold_num[BuildOrderType::Base] > 0)
						as_flag = true;
					if(as_flag && !CimexFlag::next_mybase_flag){
						temp_next_mybase = mapdata.getNextMybase();
						if(temp_next_mybase != NULL){
							new_flag = true;
							w.setMovetoTp(temp_next_mybase->getTilePosition());
							mapdata.addMybaseNum();
							CimexFlag::next_mybase_flag = true;
							return true;
						}
					}
				}
				//ȊOmybase̎̂ǂɌ
				if(!new_flag){
					BWAPI::TilePosition temptp = spiralBuildSerch(w.getNowLocation()->getTilePosition(), type);

					if(temptp == BWAPI::TilePositions::None){
						return false;
					}else{
						w.setMovetoTp(temptp);
						return true;
					}
				}
			}else{//Refinery
				BOOST_FOREACH(ResourceData &r, resources){
					if(r.getUnit() == NULL || r.getType() != BWAPI::UnitTypes::Resource_Vespene_Geyser || r.getState() != ResourceState::Mine) continue;
					w.setMovetoTp(r.getTposition());
					return true;
				}
			}
		}else{//CreepColony
			//out2 << "2-0-1" << std::endl;
			BWTA::BaseLocation *fl = mapdata.getFrontLine();
			//out2 << "2-0-2" << std::endl;
			BWAPI::TilePosition spiraltp = fl->getTilePosition();
			if(BuildOrderData::hold_num[BuildOrderType::CreepColony] >= 0 && !fl->getMinerals().empty()){
				std::set<BWAPI::Unit*>::const_iterator mb = fl->getMinerals().begin();
				for(int i=0; i<4; i++) mb++;

				BWAPI::TilePosition flt = fl->getTilePosition();
				BWAPI::TilePosition mbt = (*mb)->getTilePosition();
				int vx = flt.x() - mbt.x();
				int vy = flt.y() - mbt.y();

				spiraltp.x() = flt.x() + vx;
				spiraltp.y() = flt.y() + vy;
			}
			//out2 << "2-0-3" << std::endl;
			BWAPI::TilePosition temptp = spiralBuildSerch(spiraltp, type);
			if(temptp == BWAPI::TilePositions::None){
				return false;
			}else{
				w.setMovetoTp(temptp);
				return true;
			}
			
		}
	}
	return false;
}

void WorkerManager::build(WorkerData &w){
	if(BWAPI::Broodwar->isExplored(w.getMovetoTp())){
		w.getUnit()->build(w.getMovetoTp(), w.getBuilding());
		return;
	}else{
		BWAPI::Position p(w.getMovetoTp());
		p.x() = w.getMovetoTp().x() * 32 + 16;
		p.y() = w.getMovetoTp().y() * 32 + 16;
		w.getUnit()->move(p);
	}
}

void WorkerManager::removeWorker(BWAPI::Unit *unit){
	WorkerData temp_worker;
	BOOST_FOREACH(WorkerData w, workers){
		if(w.getId() == unit->getID()) temp_worker = w;
	}
	if(temp_worker.getId() != -1){
		if(temp_worker.getTarget() != NULL) temp_worker.getTarget()->subAssigned(); //~l̊蓖Đ
		if(temp_worker.getState() == WorkerState::Build) playerdata.sub_build_reserv(temp_worker.getBuilding()); //\񂵂Ăɖ߂
		if(temp_worker.getState() == WorkerState::Build && temp_worker.getBuilding() == BWAPI::UnitTypes::Zerg_Hatchery){
			if(CimexFlag::next_mybase_flag){ //̊nɍsĂjbgȂ
				bool flag = true;
				/*BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsOnTile(temp_next_mybase->getTilePosition().x(), temp_next_mybase->getTilePosition().y())){
					if(u->getType() == BWAPI::UnitTypes::Zerg_Hatchery){
						flag = true;
						break;
					}
				}*/
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(temp_next_mybase->getPosition(), 128)){
					if(!u->exists() || u->getPlayer() == BWAPI::Broodwar->enemy()) continue;
					if(u->getType().isResourceDepot()) flag = false;
				}

				if(flag){  //ɍshatchery݂ȂȂ
					CimexFlag::next_mybase_flag = false;
					mapdata.setNextMybase(temp_next_mybase); //nɖ߂
					temp_next_mybase = NULL;
					mapdata.subMybaseNum(); //my_base̐炷(sđ₵Ă)
				}
			}
		}
		workers.erase(temp_worker);
	}
}

void WorkerManager::createWorker(BWAPI::Unit *unit){
	workers.insert(WorkerData(unit));
}

BWAPI::TilePosition WorkerManager::spiralBuildSerch(BWAPI::TilePosition tile, BWAPI::UnitType type){
	int	x = tile.x();
	int	y = tile.y();
	int dx = 0,dy = 1;
	int length = 1;
	int curve = 0;
	bool first = true;
	bool success = false;
	while(1/*x >= 0 && x < mapdata.getMapwidth() && y >= 0 && y < mapdata.getMapheight()*/){
		if(mapdata.getBuildableMap()[x][y]){
			bool flag = true;
			for(int i=0; i<type.tileWidth(); i++){
				for(int j=0; j<type.tileHeight(); j++){
					if(x + i < 0 
						|| x + i >= mapdata.getMapwidth() 
						|| y + j < 0 
						|| y + j >= mapdata.getMapheight() 
						|| mapdata.getBuildableMap()[x+i][y+j] == NULL 
						|| !mapdata.getBuildableMap()[x+i][y+j]){
							flag = false;
							goto label1;
					}
				}
			}
label1:
			if(flag){
				success = true;
				break;
			}
		}

		do{
			x = x + dx;
			y = y + dy;
			curve++;
			if(curve == length){
				curve = 0;
				if(!first) length++;
				first = !first;
				if(dx == 0){
					dx = dy;
					dy = 0;
				}else{
					dy = -dx;
					dx = 0;
				}
			}
			if ( length > 32 ) break;
		}while(x < 0 || x >= mapdata.getMapwidth() || y < 0 || y >= mapdata.getMapheight());
		if ( length > 32 ) break;
	}

	if(success) return BWAPI::TilePosition(x,y);
	else return BWAPI::TilePositions::None;
}
